import datetime

""" 逐行讀取文字檔並傳回陣列 """
def read_file_into_list(file_loc,write_mode="r",encode_set="utf-8",split_char="\n"):
    tmp_list=open(file_loc,write_mode,encoding=encode_set).read().split(split_char)
    out_list=[]
    for i in tmp_list:
        i_list=i.split("\t")
        if len(i_list)==4 and i_list[1].find("/")>-1:
            #將日期格式調為"年月日"(目前是"日月年")
            date_split=i_list[1].split("/")
            i_list[1]=date_split[2]+"/"+fix_date_0(date_split[1])+"/"+fix_date_0(date_split[0])
            out_list.append(i_list)
    return out_list

""" 將陣列元素逐行寫入文字檔 """
def write_file_from_list(file_loc,tmp_list=[],write_mode="w+",encode_set="utf-8"):
    if len(tmp_list)!=0:
        with open(file_loc,write_mode,encoding=encode_set) as f:
            for i in tmp_list:
                f.writelines(i+'\n')
        f.close()
        print("[ OK ] 陣列寫入文字檔 "+get_file_fullname(file_loc)+" 完成!  文件編碼:"+encode_set+"")
    else:
        print("[ XX ] 陣列寫入文字檔 "+get_file_fullname(file_loc)+" 失敗!")
        return False

""" 取得完整檔名(不含路徑) """
def get_file_fullname(input_str1):
    return input_str1.split("\\")[-1]

def fix_date_0(arg):
    return arg.strip().rjust(2,"0")

def day_of_year(day_str):
    return datetime.date(int(day_str[0:4]),int(day_str[5:7]),int(day_str[8:10])).timetuple().tm_yday

def get_weekday(day_str):
    return datetime.date(int(day_str[0:4]),int(day_str[5:7]),int(day_str[8:10])).weekday()

def reduce_d_str(tmp_str):
    return tmp_str[0:10]+"~"+tmp_str[-5:] if len(tmp_str)>10 else tmp_str

def print_row(tmpid,tmp_days,tmp_events):
    if tmp_days.find(',')<0: # 只有一個日期
        return tmpid+'\t'+tmpid+' '+tmp_events+' '+tmp_days+'\t'+'同一人同月份,1種假期類別,申請時間單日'
    else:
        tmp_events_list=tmp_events.split(',')
        events_collection_list=[]
        for i in tmp_events_list:
            if i not in events_collection_list: events_collection_list.append(i)
        #print(tmp_events_list)
        tmp_days_list=tmp_days.split(',')
        #print(tmp_days_list)
        #把休假日期跟種類轉成陣列 用來進行分析 例如
        if len(events_collection_list)==1: #只有一個種類
            month_collect=[]
            for i in tmp_days_list:
                #抓取月份字串，如果month_collect內沒有就把它放入moth_collect
                tmp_mon=i[6:8]
                if tmp_mon not in month_collect:
                    month_collect.append(tmp_mon)
            mon_str="同月份"
            if len(month_collect)>1:
                mon_str="不同月份"
            return tmpid+'\t'+tmpid+' '+events_collection_list[0]+' '+reduce_d_str(tmp_days)+'\t'+'同一人'+mon_str+',1種假期類別,申請時間連續多個單日'
        else:
            result_txt=""
            month_collect=[]
            for i in events_collection_list:
                if result_txt!="":
                    result_txt+=","
                result_txt+=i
                tmp_txt=""
                for j in range(0,len(tmp_events_list)):
                    #抓取月份字串，如果month_collect內沒有就把它放入moth_collect
                    tmp_mon=tmp_days_list[j][6:8]
                    if tmp_mon not in month_collect:
                        month_collect.append(tmp_mon)
                    if tmp_events_list[j]==i:
                        if tmp_txt!="":
                            tmp_txt+=","
                        tmp_txt+=tmp_days_list[j]
                if tmp_txt.find(",")!=-1:
                    tmp_txt=reduce_d_str(tmp_txt)
                result_txt+= tmp_txt
            mon_str="同月份"
            if len(month_collect)>1:
                mon_str="不同月份"
            result_txt+="\t同一人"+mon_str+","+str(len(events_collection_list))+"種假期類別,申請時間連續多個單日"
            
            return tmpid+'\t'+tmpid+' '+result_txt


if __name__ == "__main__":
    source_txt="假期分類.txt"
    final_txt="假期分類_完成.txt"
    # 讀取"假期分類.txt"並轉成陣列
    list_source=read_file_into_list(source_txt,encode_set="Big5")
    result_list=[]
    result_list.append("員工號碼 \t 生成結果 \t 解釋")
    id_list=[]
    for i in list_source:
        if i[0] not in id_list:
            id_list.append(i[0])
    #print('用戶編號 陣列 : ',id_list,'\n')
    #用日期欄做排序
    list_source=sorted(list_source,key=lambda x: x[1])
    day_box=[]
    event_box=[]
    for i in id_list:
        current_id=i
        tmp_row=[]
        for j in list_source:
            if j[0]==current_id:
                tmp_row.append(j)
        #print('userid: ',i,"  TotalRow: ",len(tmp_row))
        days_str=""
        event_str=""
        last_date=""
        for k in range(0,len(tmp_row)):
            #print(tmp_row[k])
            if days_str=="": #第一筆
                last_date=tmp_row[k][1]
                days_str+=tmp_row[k][1]
                event_str+=tmp_row[k][2]
            elif day_of_year(last_date)+1==day_of_year(tmp_row[k][1]) or (get_weekday(last_date)==5 and get_weekday(tmp_row[k][1])):
                days_str+=","+tmp_row[k][1]
                event_str+=","+tmp_row[k][2]
                last_date=tmp_row[k][1]
            else:
                result_list.append(print_row(i,days_str,event_str))
                #print(i+'\t'+reduce_d_str(days_str),"::",event_str)
                days_str=tmp_row[k][1]
                event_str=tmp_row[k][2]
                last_date=tmp_row[k][1]
        #最末筆
        result_list.append(print_row(i,days_str,event_str))
        #print("-----------")
    #將 result_list 轉存為 txt
    write_file_from_list(final_txt,result_list,encode_set="Big5")
